<?php

/**
 * Banner Section
 *
 * @package florist_bouquet
 */

$wp_customize->add_section(
	'florist_bouquet_banner_section',
	array(
		'panel'    => 'florist_bouquet_front_page_options',
		'title'    => esc_html__( 'Banner Section', 'florist-bouquet' ),
		'priority' => 10,
	)
);

// Banner Section - Enable Section.
$wp_customize->add_setting(
	'florist_bouquet_enable_banner_section',
	array(
		'default'           => true,
		'sanitize_callback' => 'florist_bouquet_sanitize_switch',
	)
);

$wp_customize->add_control(
	new Florist_Bouquet_Toggle_Switch_Custom_Control(
		$wp_customize,
		'florist_bouquet_enable_banner_section',
		array(
			'label'    => esc_html__( 'Enable Banner Section', 'florist-bouquet' ),
			'section'  => 'florist_bouquet_banner_section',
			'settings' => 'florist_bouquet_enable_banner_section',
		)
	)
);

if ( isset( $wp_customize->selective_refresh ) ) {
	$wp_customize->selective_refresh->add_partial(
		'florist_bouquet_enable_banner_section',
		array(
			'selector' => '#florist_bouquet_banner_section .section-link',
			'settings' => 'florist_bouquet_enable_banner_section',
		)
	);
}

// Banner Section - Banner Slider Content Type.
$wp_customize->add_setting(
	'florist_bouquet_banner_slider_content_type',
	array(
		'default'           => 'post',
		'sanitize_callback' => 'florist_bouquet_sanitize_select',
	)
);

$wp_customize->add_control(
	'florist_bouquet_banner_slider_content_type',
	array(
		'label'           => esc_html__( 'Select Banner Slider Content Type', 'florist-bouquet' ),
		'section'         => 'florist_bouquet_banner_section',
		'settings'        => 'florist_bouquet_banner_slider_content_type',
		'type'            => 'select',
		'active_callback' => 'florist_bouquet_is_banner_slider_section_enabled',
		'choices'         => array(
			'page' => esc_html__( 'Page', 'florist-bouquet' ),
			'post' => esc_html__( 'Post', 'florist-bouquet' ),
		),
	)
);

// Banner Slider Category Setting.
$wp_customize->add_setting('florist_bouquet_banner_slider_category', array(
	'default'           => 'slider',
	'sanitize_callback' => 'sanitize_text_field',
));

// Add custom control for Banner Slider Category with conditional visibility.
$wp_customize->add_control(new WP_Customize_Category_Dropdown_Control($wp_customize, 'florist_bouquet_banner_slider_category', array(
	'label'    => __('Select Banner Category', 'florist-bouquet'),
	'section'  => 'florist_bouquet_banner_section',
	'settings' => 'florist_bouquet_banner_slider_category',
	'active_callback' => function() use ($wp_customize) {
		return $wp_customize->get_setting('florist_bouquet_banner_slider_content_type')->value() === 'post';
	},
)));

for ( $florist_bouquet_i = 1; $florist_bouquet_i <= 3; $florist_bouquet_i++ ) {

	// Banner Section - Select Banner Post.
	$wp_customize->add_setting(
		'florist_bouquet_banner_slider_content_post_' . $florist_bouquet_i,
		array(
			'sanitize_callback' => 'absint',
		)
	);

	$wp_customize->add_control(
		'florist_bouquet_banner_slider_content_post_' . $florist_bouquet_i,
		array(
			/* translators: %d: Select Post Count. */
			'label'           => sprintf( esc_html__( 'Select Post %d', 'florist-bouquet' ), $florist_bouquet_i ),
			'description'     => sprintf( esc_html__( 'Kindly :- Select a Post based on the category selected in the upper settings', 'florist-bouquet' ), $florist_bouquet_i ),
			'section'         => 'florist_bouquet_banner_section',
			'settings'        => 'florist_bouquet_banner_slider_content_post_' . $florist_bouquet_i,
			'active_callback' => 'florist_bouquet_is_banner_slider_section_and_content_type_post_enabled',
			'type'            => 'select',
			'choices'         => florist_bouquet_get_post_choices(),
		)
	);

	// Banner Section - Select Banner Page.
	$wp_customize->add_setting(
		'florist_bouquet_banner_slider_content_page_' . $florist_bouquet_i,
		array(
			'sanitize_callback' => 'absint',
		)
	);

	$wp_customize->add_control(
		'florist_bouquet_banner_slider_content_page_' . $florist_bouquet_i,
		array(
			/* translators: %d: Select Page Count. */
			'label'           => sprintf( esc_html__( 'Select Page %d', 'florist-bouquet' ), $florist_bouquet_i ),
			'section'         => 'florist_bouquet_banner_section',
			'settings'        => 'florist_bouquet_banner_slider_content_page_' . $florist_bouquet_i,
			'active_callback' => 'florist_bouquet_is_banner_slider_section_and_content_type_page_enabled',
			'type'            => 'select',
			'choices'         => florist_bouquet_get_page_choices(),
		)
	);

	// Banner Section - Button Label.
	$wp_customize->add_setting(
		'florist_bouquet_banner_button_label_' . $florist_bouquet_i,
		array(
			'default'           => '',
			'sanitize_callback' => 'sanitize_text_field',
		)
	);

	$wp_customize->add_control(
		'florist_bouquet_banner_button_label_' . $florist_bouquet_i,
		array(
			/* translators: %d: Button Label Count. */
			'label'           => sprintf( esc_html__( 'Button Label %d', 'florist-bouquet' ), $florist_bouquet_i ),
			'section'         => 'florist_bouquet_banner_section',
			'settings'        => 'florist_bouquet_banner_button_label_' . $florist_bouquet_i,
			'type'            => 'text',
			'active_callback' => 'florist_bouquet_is_banner_slider_section_enabled',
		)
	);

	// Banner Section - Button Link.
	$wp_customize->add_setting(
		'florist_bouquet_banner_button_link_' . $florist_bouquet_i,
		array(
			'default'           => '',
			'sanitize_callback' => 'esc_url_raw',
		)
	);

	$wp_customize->add_control(
		'florist_bouquet_banner_button_link_' . $florist_bouquet_i,
		array(
			/* translators: %d: Button Link Count. */
			'label'           => sprintf( esc_html__( 'Button Link %d', 'florist-bouquet' ), $florist_bouquet_i ),
			'section'         => 'florist_bouquet_banner_section',
			'settings'        => 'florist_bouquet_banner_button_link_' . $florist_bouquet_i,
			'type'            => 'url',
			'active_callback' => 'florist_bouquet_is_banner_slider_section_enabled',
		)
	);
}

// Banner Button Label Color
$wp_customize->add_setting(
	'florist_bouquet_banner_btn_color',
	array(
		'default' => '',
		'sanitize_callback' => 'sanitize_hex_color',
	)
);
$wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'florist_bouquet_banner_btn_color',array(
			'label' => __('Banner Button Label Color','florist-bouquet'),
			'section' => 'florist_bouquet_banner_section',
			'settings' => 'florist_bouquet_banner_btn_color',
			'active_callback' => 'florist_bouquet_is_banner_slider_section_enabled',
		)
	)
);

// Banner Button Background Color
$wp_customize->add_setting('florist_bouquet_banner_btn_bg_color',array(
		'default' => '',
		'sanitize_callback' => 'sanitize_hex_color',
	)
);
$wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'florist_bouquet_banner_btn_bg_color',array(
			'label' => __('Banner Button Background Color','florist-bouquet'),
			'section' => 'florist_bouquet_banner_section',
			'settings' => 'florist_bouquet_banner_btn_bg_color',
			'active_callback' => 'florist_bouquet_is_banner_slider_section_enabled',
		)
	)
);